Subject: Re: [PATCH v2 2/3] remote: repack packed-refs once when deleting multiple refs

From: Junio C Hamano <[email-masked]>
Date: Fri, 23 May 2014 12:11:57 -0700

Jens Lindström <[email-masked]> writes:

> When 'git remote rm' or 'git remote prune' were used in a repository
> with many refs, and needed to delete many remote-tracking refs, a lot
> of time was spent deleting those refs since for each deleted ref,
> repack_without_refs() was called to rewrite packed-refs without just
> that deleted ref.
>
> To avoid this, call repack_without_refs() first to repack without all
> the refs that will be deleted, before calling delete_ref() to delete
> each one completely.  The call to repack_without_ref() in delete_ref()
> then becomes a no-op, since packed-refs already won't contain any of
> the deleted refs.
>
> Signed-off-by: Jens Lindström <[email-masked]>
> ---
> Note: remove_branches() no longer checks that the remote-tracking
> branches it deletes point at the right object before deleting them
> by passing the expected SHA-1 to delete_ref().  This was a required
> change since all packed refs have been deleted already by the time
> we call delete_ref(), which causes delete_ref() to fail if given an
> expected SHA-1 to check.  'remote prune' already behaved this way.
>
>  builtin/remote.c | 20 ++++++++++++++++++--
>  refs.c           |  2 +-
>  refs.h           |  2 ++
>  3 files changed, 21 insertions(+), 3 deletions(-)
>
> diff --git a/builtin/remote.c b/builtin/remote.c
> index 84802cd..d33abe6 100644
> --- a/builtin/remote.c
> +++ b/builtin/remote.c
> @@ -749,15 +749,23 @@ static int mv(int argc, const char **argv)
>  
>  static int remove_branches(struct string_list *branches)
>  {
> +	const char **branch_names;
>  	int i, result = 0;
> +
> +	branch_names = xmalloc(branches->nr * sizeof(*branch_names));
> +	for (i = 0; i < branches->nr; i++)
> +		branch_names[i] = branches->items[i].string;
> +	result |= repack_without_refs(branch_names, branches->nr);
> +	free(branch_names);

Hmph.  I wonder if you can refactor/enhance the interface to the
repack_without_refs() function before this step in the series, so
that the function lets the caller to know if each ref was actually
removed or it was not in packed-refs from the beginning, and also I
wonder if such a refactoring helps.  My gut feeling is that it would
not help that much this particular series, but it would probably be
a good thing to do in the longer run. So probably it is better to do
without such a change as a part of this series.

>  	for (i = 0; i < branches->nr; i++) {
>  		struct string_list_item *item = branches->items + i;
>  		const char *refname = item->string;
> -		unsigned char *sha1 = item->util;

Here, you can check if the refname still exists as a ref; if it no
longer exists, it would mean that the only copy of the ref was in
the packed-refs file and you have already deleted it, and you can
refrain from calling delete_ref() altogether, e.g.

	if (!ref_exists(refname))
		continue; /* already removed the sole copy from packed-ref */

and then still retain the safetly against racing somebody else who
created or updated the ref you wanted to remove here by passing the
object name to delete_ref().

> -		if (delete_ref(refname, sha1, 0))
> +		if (delete_ref(refname, NULL, 0))
>  			result |= error(_("Could not remove branch %s"), refname);
>  	}
> +
>  	return result;
>  }